/* AMX Mod script. 
* 
* (c) 2003, OLO 
* This file is provided as is (no warranties). 
*
* Commands:
* amx_restmenu - displays restriction menu
* amx_restrict <menu> <team> [key] - sets restriction for weapon
* Examples:
* amx_restrict pistol CT 123
* amx_restrict rifle T 12
* amx_restrict rifle T (removes restriction from rifle menu)
* amx_restrict rifle (removes restriction from rifle menu for both teams)
*/ 

#include <amxmod> 
#include <amxmisc> 

// Uncomment if you want to have seperate settings for each map
//#define MAPSETTINGS
// Uncomment if you are running CS 1.6
//#define CSTRIKE16

new g_Position[33]
new g_Modified
new g_blockPos[112] // 7 (menus) * 8 (keys) * 2 (teams)

#if defined CSTRIKE16
#define MAXMENUPOS 34
#else
#define MAXMENUPOS 31
#endif

#if defined MAPSETTINGS
new g_File[64] // this will be "addons/amx/weaprest_mapname.ini" (see plugin_init)
#else
new g_File[] = "addons/amx/weaprest.ini"  
#endif

// First position is a position of menu (0 for ammo, 1 for pistols, 6 for equipment etc.)
// Second is a key for TERRORIST (all is key are minus one, 1 is 0, 2 is 1 etc.)
// Third is a key for CT
// Position with -1 doesn't exist
new g_Keys[MAXMENUPOS][3] = { 
#if defined CSTRIKE16
  {6,0,0}, // Kevlar Vest
  {6,1,1}, // Kevlar Vest & Helmet
  {6,2,2}, // Flashbang
  {6,3,3}, // HE Grenade
  {6,4,4}, // Smoke Grenade
  {6,-1,6}, // Defuse Kit
  {6,5,5}, // NightVision Goggles
  {6,-1,7}, // Tactical Shield
  {0,5,5}, // Primary weapon ammo
  {0,6,6}, // Secondary weapon ammo

  {1,1,1}, // H&K USP .45 Tactical
  {1,0,0}, // Glock18 Select Fire
  {1,3,3}, // Desert Eagle .50AE
  {1,2,2}, // SIG P228
  {1,4,-1}, // Dual Beretta 96G Elite
  {1,-1,4}, // FN Five-Seven

  {2,0,0}, // Benelli M3 Super90
  {2,1,1}, // Benelli XM1014

  {3,1,1}, // H&K MP5-Navy
  {3,-1,0}, // Steyr Tactical Machine Pistol
  {3,3,3}, // FN P90
  {3,0,-1}, // Ingram MAC-10
  {3,2,2}, // H&K UMP45

  {4,1,-1}, // AK-47
  {4,0,-1}, // Gali
  {4,-1,0}, // Famas
  {4,3,-1}, // Sig SG-552 Commando
  {4,-1,2}, // Colt M4A1 Carbine
  {4,-1,3}, // Steyr Aug

  {4,2,1}, // Steyr Scout
  {4,4,5}, // AI Arctic Warfare/Magnum
  {4,5,-1}, // H&K G3/SG-1 Sniper Rifle
  {4,-1,4}, // Sig SG-550 Sniper

  {5,0,0}  // FN M249 Para
#else
  {6,0,0}, // Kevlar Vest
  {6,1,1}, // Kevlar Vest & Helmet
  {6,2,2}, // Flashbang
  {6,3,3}, // HE Grenade
  {6,4,4}, // Smoke Grenade
  {6,-1,5}, // Defuse Kit
  {6,6,6}, // NightVision Goggles
  {0,5,5}, // Primary weapon ammo
  {0,6,6}, // Secondary weapon ammo

  {1,0,0}, // H&K USP .45 Tactical
  {1,1,1}, // Glock18 Select Fire
  {1,2,2}, // Desert Eagle .50AE
  {1,3,3}, // SIG P228
  {1,4,-1}, // Dual Beretta 96G Elite
  {1,-1,5}, // FN Five-Seven

  {2,0,0}, // Benelli M3 Super90
  {2,1,1}, // Benelli XM1014

  {3,0,0}, // H&K MP5-Navy
  {3,-1,1}, // Steyr Tactical Machine Pistol
  {3,2,2}, // FN P90
  {3,3,-1}, // Ingram MAC-10
  {3,4,4}, // H&K UMP45

  {4,0,-1}, // AK-47
  {4,1,-1}, // Sig SG-552 Commando
  {4,-1,2}, // Colt M4A1 Carbine
  {4,-1,3}, // Steyr Aug

  {4,4,4}, // Steyr Scout
  {4,5,5}, // AI Arctic Warfare/Magnum
  {4,6,-1}, // H&K G3/SG-1 Sniper Rifle
  {4,-1,7}, // Sig SG-550 Sniper

  {5,0,0}  // FN M249 Para
#endif
}

new g_menusNames[7][] = {"buy","pistol","shotgun","sub","rifle","machine","item"} 

new g_WeaponNames[MAXMENUPOS][] = {
  "Kevlar Vest",
  "Kevlar Vest & Helmet",
  "Flashbang",
  "HE Grenade",
  "Smoke Grenade",
  "Defuse Kit",
  "NightVision Goggles",
#if defined CSTRIKE16 
  "Tactical Shield",
#endif
  "Primary weapon ammo",
  "Secondary weapon ammo",
  "H&K USP .45 Tactical",
  "Glock18 Select Fire",
  "Desert Eagle .50AE",
  "SIG P228",
  "Dual Beretta 96G Elite",
  "FN Five-Seven",
  "Benelli M3 Super90",
  "Benelli XM1014",
  "H&K MP5-Navy",
  "Steyr Tactical Machine Pistol",
  "FN P90",
  "Ingram MAC-10",
  "H&K UMP45",
  "AK-47",
#if defined CSTRIKE16
  "Gali",
  "Famas",
#endif
  "Sig SG-552 Commando",
  "Colt M4A1 Carbine",
  "Steyr Aug",
  "Steyr Scout",
  "AI Arctic Warfare/Magnum",
  "H&K G3/SG-1 Sniper Rifle",
  "Sig SG-550 Sniper",
  "FN M249 Para"
}

new g_Weapons[MAXMENUPOS][] = { 
  "\yEquipment^n\w^n%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w",
#if defined CSTRIKE16
  "%d. %s\y\R%s^n\w",
#endif  
  "%d. %s\y\R%s^n\w",
  "%d. %s\y\R%s^n\w^n", 

  "\yHandgun^n\w^n%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w^n", 

  "\yShotgun^n\w^n%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w^n", 

  "\ySub-Machine Gun^n\w^n%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w^n", 

  "\yAssault Rifle^n\w^n%d. %s\y\R%s^n\w", 
#if defined CSTRIKE16
  "%d. %s\y\R%s^n\w",
  "%d. %s\y\R%s^n\w",
#endif  
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w^n", 

  "\ySniper Rifle^n\w^n%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w", 
  "%d. %s\y\R%s^n\w^n", 

  "\yMachine Gun^n\w^n%d. %s\y\R%s^n\w" 
} 

public plugin_init(){ 
  register_plugin("Restrict Weapons","0.9.4","default")
  register_clcmd("buyammo1","ammoRest1")
  register_clcmd("buyammo2","ammoRest2")  
  register_clcmd("amx_restmenu","cmdMenu",ADMIN_CFG,"- displays weapons restriction menu")
  register_menucmd(register_menuid("\yRestrict Weapons"),1023,"actionMenu")
  register_menucmd(register_menuid("#Buy", 1 ),511,"menuBuy")
  register_menucmd(register_menuid("BuyPistol", 1 ),511,"menuPistol")
  register_menucmd(register_menuid("BuyShotgun", 1 ),511,"menuShotgun")
  register_menucmd(register_menuid("BuySub", 1 ),511,"menuSub")
  register_menucmd(register_menuid("BuyRifle", 1 ),511,"menuRifle")
  register_menucmd(register_menuid("BuyMachine", 1 ),511,"menuMachine")
  register_menucmd(register_menuid("BuyItem", 1 ),511,"menuItem")
  register_menucmd(-28,511,"menuBuy" )
  register_menucmd(-29,511,"menuPistol" )
  register_menucmd(-30,511,"menuShotgun")
  register_menucmd(-32,511,"menuSub")
  register_menucmd(-31,511,"menuRifle")
  register_menucmd(-33,511,"menuMachine")
  register_menucmd(-34,511,"menuItem")
  register_concmd("amx_restrict","cmdRestrict",ADMIN_CFG,"<menu> <team> [keys] - restrict weapons (no keys removes restriction)")

#if defined MAPSETTINGS
  new mapname[32]
  get_mapname(mapname,31)
  format( g_File , 63, "addons/amx/weaprest_%s.ini" , mapname )
#endif
        
  loadSettings(g_File)
}

findMenuId( name[] ){
  for(new i = 0; i < 7 ; ++i)
    if( equal( name , g_menusNames[i] ) )
      return i     
  return -1
}

readSetting( id , arg[], arg2[] ){ 
  new a = 0, a2 = 0 
  for(new i = 0; i < 9 ; ++i ){
    if ( g_blockPos[ id * 8 + i ] )
      arg[a++] = '1' + i
    if ( g_blockPos[ id * 8 + i + 56 ] )
      arg2[a2++] = '1' + i      
  }
  arg[a] = arg2[a2] = 0
}

public cmdRestrict(id,level,cid){ 
  if (!cmd_access(id,level,cid,2))
      return PLUGIN_HANDLED
  new szTemp[16]
  read_argv(1,szTemp,15)
  new menuID = findMenuId( szTemp ) 
  if (menuID == -1){ // Bad menu name
    console_print(id,"Menus: ^"buy^", ^"pistol^", ^"shotgun^", ^"sub^", ^"rifle^", ^"machine^", ^"item^"") 
    return PLUGIN_HANDLED 
  }
  read_argv( 2 , szTemp , 15 )  
  new iTeam = equali( szTemp, "CT" ) ? 56 : 0
  new argc = read_argc()
  if ( argc < 4 ) { // Remove all restriction
    if ( argc > 2 ) {
      setc(g_blockPos[ (menuID * 8) + iTeam ], 8 , 0 )
      console_print(id,"Restriction removed (menu ^"%s^") (team ^"%s^")",
        g_menusNames[menuID] , iTeam ? "CT" : "TERRORIST" )
    }
    else  {
      setc(g_blockPos[ (menuID * 8) ], 8 , 0 )
      setc(g_blockPos[ (menuID * 8) + 56 ], 8 , 0 )
      console_print(id,"Restriction removed (menu ^"%s^") for both teams",g_menusNames[menuID] )      
    }
    return PLUGIN_HANDLED
  }
  read_argv( 3 , szTemp , 15 )
  for(new  d = 0; szTemp[d] ; d++ ){
    if ( szTemp[d] >= '1' && szTemp[d] <= '9' )
      g_blockPos[ ( menuID * 8 + (szTemp[d] - '1') ) + iTeam ] = 1
  }
  new szTemp2[16]
  readSetting( menuID , szTemp, szTemp2 )
  console_print( id , "Restriction set (menu ^"%s^") (team ^"TERRORIST^") (keys ^"%s^") (team ^"CT^") (keys ^"%s^")" ,
    g_menusNames[ menuID ] , szTemp, szTemp2 )
  return PLUGIN_HANDLED
} 

displayMenu(id,pos){ 
   if (pos < 0) return
   new menubody[512], start = pos * 7 
   if (start >= MAXMENUPOS) start = pos = g_Position[id] = 0 
   new len = format(menubody,511,"\yRestrict Weapons\R%d/5^n\w^n",pos+1) 
   new end = start + 7, keys = (1<<9)|(1<<7), k = 0
   new d, m
   if (end > MAXMENUPOS) end = 31 
   for(new a = start; a < end; ++a){ 
      keys |= (1<<k)
      m = g_Keys[a][0] * 8
      d = ( g_Keys[a][1]==-1) ? 0 : g_blockPos[ m + g_Keys[a][1] ] // check T key
      d += ( g_Keys[a][2]==-1) ? 0 : g_blockPos[ m + g_Keys[a][2] + 56  ] // check CT key
      len += format(menubody[len],511-len,g_Weapons[a],++k,g_WeaponNames[a],  d ? "ON" : "OFF" )
   } 
   len += format(menubody[len],511-len,"^n8. Save settings \y\R%s^n\w",g_Modified?"*":"") 
   if (end != MAXMENUPOS){ 
      len += format(menubody[len],511-len,"^n9. More...^n0. %s", pos ? "Back" : "Exit") 
      keys |= (1<<8) 
   } 
   else {
      len += format(menubody[len],511-len,"^n0. %s", pos ? "Back" : "Exit") 
   }
   show_menu(id,keys,menubody) 
} 

public actionMenu(id,key){ 
   switch(key){ 
   case 7: { 
      if (saveSettings(g_File)){ 
        g_Modified = false 
        client_print(id,print_chat,"* Configuration saved successfully") 
      }
      else client_print(id,print_chat,"* Configuration saving failed!!!") 
      displayMenu(id,g_Position[id]) 
    } 
   case 8: displayMenu(id,++g_Position[id]) 
   case 9: displayMenu(id,--g_Position[id]) 
   default: {
        new b, a = g_Position[id] * 7 + key
        new m = g_Keys[a][0] * 8
        if (g_Keys[a][1] != -1) {
          b = m + g_Keys[a][1]
          g_blockPos[ b ] = 1 - g_blockPos[ b ]
        }
        if (g_Keys[a][2] != -1) {
          b = m + g_Keys[a][2] + 56
          g_blockPos[ b ] = 1 - g_blockPos[ b ]
        }
        g_Modified = true
        displayMenu(id,g_Position[id]) 
      } 
   } 
   return PLUGIN_HANDLED 
} 

public cmdMenu(id,level,cid){ 
  if (cmd_access(id,level,cid,1)) 
    displayMenu(id, g_Position[id] = 0 ) 
  return PLUGIN_HANDLED 
} 

checkRest(id,menu,key){
  if ( g_blockPos[ (menu * 8 + key) + (get_user_team(id) - 1) * 56 ] ){
    engclient_cmd(id,"menuselect","10") 
    client_print(id,print_center,"* This position is restricted *")
    return PLUGIN_HANDLED 
  } 
  return PLUGIN_CONTINUE 
} 

public ammoRest1(id)        return checkRest(id,0,5)
public ammoRest2(id)        return checkRest(id,0,6)
public menuBuy(id,key)      return checkRest(id,0,key)
public menuPistol(id,key)   return checkRest(id,1,key)
public menuShotgun(id,key)  return checkRest(id,2,key)
public menuSub(id,key)      return checkRest(id,3,key)
public menuRifle(id,key)    return checkRest(id,4,key)
public menuMachine(id,key)  return checkRest(id,5,key)
public menuItem(id,key)     return checkRest(id,6,key)

saveSettings(sFilename[]){ 
  if (file_exists(sFilename)) 
    delete_file(sFilename) 
  new szText[256], d, m 
  if (!write_file(sFilename,";Generated by Restrict Weapons Plugin. Do not modify!^n;Menu Key Key")) 
    return 0
  for(new a = 0; a < MAXMENUPOS; ++a){
    m = g_Keys[a][0] * 8
    d = ( g_Keys[a][1]==-1 ) ? 0 : g_blockPos[ m + g_Keys[a][1] ] // check T key
    d += ( g_Keys[a][2]==-1 ) ? 0 : g_blockPos[ m + g_Keys[a][2] + 56  ] // check CT key     
    if ( d ) {
      format(szText,255,"%d %d %d ;%s",g_Keys[a][0],g_Keys[a][1],g_Keys[a][2],g_WeaponNames[a])
      write_file(sFilename,szText)
    } 
  }
  return 1
} 

loadSettings(sFilename[]){ 
  if (!file_exists(sFilename)) return 0 
  new szText[256], szMenu[4], szKey1[4]
  new szKey2[4], ik1, ik2, m, pos = 0 
  while (read_file(sFilename,pos++,szText,255, m )){ 
    if ( szText[0] == ';' ) continue // line is a comment 
    parse(szText,szMenu,3,szKey1,3,szKey2,3)
    ik1 = strtonum( szKey1 )
    ik2 = strtonum( szKey2 )
    m = strtonum( szMenu ) * 8
    if ( ik1 != -1)
      g_blockPos[ m + ik1 ] = 1
    if ( ik2 != -1)
      g_blockPos[ m + ik2 + 56 ] = 1
  }
  return 1 
} 
